<template>
    <div class="container">
        <div class="row">
            <div class="col-sm-12">
                <hr>
            </div>
        </div>
        <div class="row" style="height: 300px;">
            <div class="col-sm-9" style="height: 100%; padding-right: 0;">
                <textarea class="form-control" style="box-sizing: border-box; height: 100%; overflow-y: scroll; resize: none; background-color: rgb(238, 238, 238); border: 1px solid rgb(200, 200, 200); border-radius: 3px;" readonly>{{messages.join('\n')}}</textarea>
            </div>
            <div class="col-sm-3" style="height: 100%; padding-left: 0;">
                <div style="box-sizing: border-box; height: 100%; margin-left: 15px; border: 1px solid rgb(200, 200, 200); border-radius: 3px;">
                    <div style="box-sizing: border-box; height: 100%; overflow-y: scroll; background-color: rgb(238, 238, 238);">
                        <ul>
                            <li v-for="user in activeUsers">{{user}}</li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <hr>
                <input type="text" class="form-control" v-model="textMessage" @keyup.enter="sendMessage" @keydown="actionUser" autofocus>
                <span v-if="isActive">{{isActive.name}} is typing...</span>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        props: [
            'room',
            'user',
        ],
        data() {
            return {
                messages: [],
                textMessage: '',
                isActive: false,
                typingTimer: false,
                activeUsers: [],
            }
        },
        computed: {
            channel() {
                return window.Echo.join('room.' + this.room.id);
            },
        },
        mounted() {
            // console.log(this.room);
            this.channel.here((users) => {
                this.activeUsers = users;
            });
            this.channel.joining((user) => {
                this.activeUsers.push(user);
            });
            this.channel.leaving((user) => {
                this.activeUsers.splice(this.activeUsers.indexOf(user), 1);
            });
            this.channel.listen('PrivateMessage', ({data}) => {
                this.messages.push(data.body);
                this.isActive = false;
            });
            this.channel.listenForWhisper('typing', (e) => {
                this.isActive = e;
                if (this.typingTimer) clearTimeout(this.typingTimer);
                this.typingTimer = setTimeout(() => {
                    this.isActive = false;
                }, 2000);
            });
        },
        methods: {
            sendMessage() {
                axios.post('/api/messages/private', {
                    body: this.textMessage,
                    room_id: this.room.id,
                });
                this.messages.push(this.textMessage);
                this.textMessage = '';
            },
            actionUser() {
                this.channel.whisper('typing', {
                    name: this.user.name
                });
            },
        },
    }
</script>
